﻿
@{
    EnergyMission.Web.Common.Common cs = new EnergyMission.Web.Common.Common();
    EnergyMission.Domain.Entities.VisulationSearchEntity vs = new VisulationSearchEntity();
    
}

@using EnergyMission.Web.Common
@using DevExpress.XtraCharts;
@using System.Drawing;
@using System.Data; 
<link href="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.5/themes/base/jquery-ui.css" rel="stylesheet" type="text/css" />

<script src="http://code.jquery.com/ui/1.10.2/jquery-ui.js"></script>




@*<link href="~/Content/jquery-ui.css" rel="stylesheet" />
<script src="~/Scripts/jquery-2.2.2.js"></script>
<script src="~/Scripts/jquery-ui-1.8.20.min.js"></script>*@
@*<script src="~/Content/js/jquery-1.10.2.js"></script>
<script src="~/Content/js/jquery-ui.js"></script>*@

@section Scripts {
<script>
  $(function() {
      $("#sdate").datepicker();
      $("#edate").datepicker();
  });

  //$(document).ready(function () {
    
      
     

  //});

  $("#SiteId").change(function () {
      var selectedT = $(this).find("option:selected").val();
      alert(selectedT);
      $.ajax({
          type: "Get",

          url: "/StructureDivisions/OnChangeOfSiteChangeStructureEntry",
          data: { "SDDdeptId": selectedT },
          contentType:"application/json;charset=utf-8",
          success: function (Result) {
              value = JSON.stringify(Result);
            
              var StructureId = $("#StructureId");
              StructureId.html('');
              StructureId.append($('<option></option>').val('').html("Select Structure"));

              $.each(Result.result, function (id, option) {


                  StructureId.append($('<option></option>').val(option.id).html(option.name));
              }
            );
          },

          error: function (textStatus, errorThrown) {
              alert("Inside error");
              alert(textStatus);
          }
      });

         

           


  });

  $("#StructureId").change(function () {
      var selectedT = $(this).find("option:selected").val();
      alert(selectedT);
      $.ajax({
          type: "Get",

          url: "/StructureDivisions/OnchangeOfStructureStructureDivisonEntry",
          data: { "StructureId": selectedT },
          contentType: "application/json;charset=utf-8",
          success: function (Result) {
              value = JSON.stringify(Result);
              // alert(value);
              var StructureDivisionId = $("#StructureDivisionId");
              StructureDivisionId.html('');
              //var mySelect = $('#SiteId');

              StructureDivisionId.append($('<option></option>').val('').html("Select Structure"));
              //alert(JSON.stringify(Result.result[0]));
              $.each(Result.result, function (id, option) {
                  //alert("inside foreach");

                  StructureDivisionId.append($('<option></option>').val(option.id).html(option.name));
              });
             
          },

          error: function (textStatus, errorThrown) {
              alert("Inside error");
              alert(textStatus);
          }
      });



    


  });


 
</script>
    }

<script>
    function onComboBoxSelectedIndexChanged(s, e) {
        var value = s.GetValue();
        alert(value);
        $('#TeamId').val(value);
    }

    function onComboBoxSelectedIndexChanged1(s, e) {
        var value = s.GetValue();
        alert(value);
        $('#SiteId').val(value);
        $.ajax({
            type: "Get",

            url: "/StructureDivisions/OnChangeOfSiteChangeStructureEntry",
            data: { "SDDdeptId": value },
            contentType: "application/json;charset=utf-8",
            success: function (Result) {
                value = JSON.stringify(Result);

                var StructureId = $("#StructureId");
                StructureId.html('');
                StructureId.append($('<option></option>').val('').html("Select Structure"));

                $.each(Result.result, function (id, option) {


                    StructureId.append($('<option></option>').val(option.id).html(option.name));
                }
              );
            },

            error: function (textStatus, errorThrown) {
                alert("Inside error");
                alert(textStatus);
            }
        });
    }
</script>
@using (Html.BeginForm())
{
  
    ChartSeriesBindingDemoOptions options = (ChartSeriesBindingDemoOptions)ViewData["OptionsKey"];
    //ChartSeriesBindingDemoOptions options = (ChartSeriesBindingDemoOptions)ViewData["OptionsKey"];
    <div class="chartOptionsPanel" style="height:auto;">
        <table>
            <tr>
                <td>
                    @*Show Labels @Html.CheckBox("ShowLabels", options.ShowLabels)*@
                </td>
                <td>
                  day  <input type="number" name="Day" />
                </td>

                <td>
                 Month  <input type="number" name="Month" />
                </td>

                <td>
                    Year  <input type="number" name="Year" />
                </td>
                <td>
                  Electricity <input type="checkbox" value="true" name="Electricitys" />
     
                         

                </td>
                <td>
                    Water  <input type="checkbox" name="Water" value="true" />
                </td>
                <td>
                    Gas  <input type="checkbox" name="Gas" value="true" />
                </td>

                <td>
                    Day  <input type="checkbox" name="IsDay" value="true" />
                </td>

                <td>
                    Night  <input type="checkbox" name="IsNight" value="true" />
                </td>
             
                <td class="NoWrap">
                    @*<label for="ShowLabels">Show Labels</label>*@
                </td>
              
                <td class="NoWrap"><label for="SeriesDataMember">Series Data Member:</label></td>
            
                <td>
                    @Html.DropDownList("SeriesDataMember", ChartDemoHelper.GetSeriesDataMembers(),"select month")
                </td>
               
               
            </tr>
            <tr>
                <td>Start_Date <input type="text" name="Start_Date" id="sdate"/> </td>

                <td>End_Date <input type="text" name="End_Date" id="edate" /> </td>

            

                
            </tr>
            <tr>
                <td> Site @Html.DropDownList("SiteId", cs.SiteList, new { @class = "form-control", @style = "width:200px" }) </td>
            </tr>
            <tr>
                <td> Site
                  

                    @Html.DevExpress().ComboBox(
  setting =>
  {
      setting.Properties.IncrementalFilteringMode = IncrementalFilteringMode.StartsWith;
      setting.Properties.DropDownStyle = DropDownStyle.DropDown;

      setting.Properties.ClientSideEvents.SelectedIndexChanged
                            = "onComboBoxSelectedIndexChanged1";
      setting.Name = "site";
      setting.Properties.FilterMinLength = 1;
      setting.Properties.CallbackPageSize = 5;
      setting.Properties.DropDownRows = 10;
      setting.Properties.IncrementalFilteringMode = IncrementalFilteringMode.Contains;

      setting.Width = 180;
      setting.SelectedIndex = -1;
      setting.Properties.TextField = "Name";
      setting.Properties.ValueField = "Id";
      setting.Properties.DropDownButton.Visible = false;
      setting.Properties.ValueType = typeof(long);
  }).BindList(cs.GetSite()
).GetHtml()

                </td>
              
            </tr>
            <tr>
                <td>Structure @Html.DropDownList("StructureId", cs.StructureList, new { @class = "form-control", @style = "width:200px" })</td>
            </tr>
            <tr>
                <td>Structure Division @Html.DropDownList("StructureDivisionId", cs.StructureDivisionList, new { @class = "form-control", @style = "width:200px" })</td>
            </tr>

            <tr>
                <td> Team @Html.DevExpress().ComboBox(
  setting =>
  {

      setting.Properties.DropDownStyle = DropDownStyle.DropDown;

      setting.Properties.ClientSideEvents.SelectedIndexChanged
                            = "onComboBoxSelectedIndexChanged";
      setting.Name = "teamname";
      setting.Properties.FilterMinLength = 1;
      setting.Properties.CallbackPageSize = 5;
      setting.Properties.DropDownRows = 10;
      setting.Properties.IncrementalFilteringMode = IncrementalFilteringMode.Contains;

      setting.Width = 180;

      setting.Properties.TextField = "Name";
      setting.Properties.ValueField = "Id";
      setting.Properties.DropDownButton.Visible = false;
      setting.Properties.ValueType = typeof(long);
  }).BindList(cs.GetAllTeams()
).GetHtml()

                <input type="hidden" name="TeamId" id="TeamId" />
                </td>
            </tr>

            <tr>
                <td><input style="float:left" type="submit" value="Apply" class="btn btn-success" />
                
                </td>
            </tr>
        </table>
    </div>
    ChartControlSettings settings = new ChartControlSettings();
   
    settings.Name = "chart";
    settings.Width = 1200;
    settings.Height = 700;
    settings.BorderOptions.Visibility = DefaultBoolean.False;
    settings.CrosshairEnabled = options.ShowLabels ? DefaultBoolean.False : DefaultBoolean.True;
    Series series = new Series();
    Series serie1 = new Series("Curent Year", DevExpress.XtraCharts.ViewType.Line);
    Series serie2 = new Series("Previous", DevExpress.XtraCharts.ViewType.Line);

    ((LineSeriesView)serie1.View).LineStyle.DashStyle = DashStyle.Dash;
    serie1.Name = "Current Year";
    serie2.Name = "Previous Year";
    series.Name = "Timespan";


    settings.Legend.Visibility = DevExpress.Utils.DefaultBoolean.True;







    serie1.View.Color = Color.Gray;
    serie1.SeriesPointsSortingKey = options.SortingKey;
    serie1.SeriesPointsSorting = options.SortingMode;
    serie1.ArgumentDataMember = "Timespan";
    serie1.ValueDataMembers[0] = "Value";
    serie2.View.Color = Color.Black;
    serie2.SeriesPointsSortingKey = options.SortingKey;
    serie2.SeriesPointsSorting = options.SortingMode;
    serie2.ArgumentDataMember = "Timespan";
    serie2.ValueDataMembers[0] = "prvValue";

    series.SeriesPointsSortingKey = options.SortingKey;
    series.SeriesPointsSorting = options.SortingMode;
    series.ArgumentDataMember = "Timespan";
    series.ArgumentScaleType = ScaleType.Numerical;
    series.ValueScaleType = ScaleType.Numerical;


    series.ValueDataMembers[0] = "Value";
    series.Tag = "Target";
    series.LabelsVisibility = options.ShowLabels ? DefaultBoolean.True : DefaultBoolean.True;
   ((BarSeriesLabel)series.Label).Position = BarSeriesLabelPosition.Top;




    settings.Series.Add(series);
    settings.Series.Add(serie1);
    settings.Series.Add(serie2);
    XYDiagram diagram = ((XYDiagram)settings.Diagram);


    //////// X Axis Setting  /////////////////////////
    diagram.AxisX.Title.Visibility = DefaultBoolean.True;

    if (ViewBag.Type == "Days")
    {
        diagram.AxisX.Title.Text = "Days";
        diagram.AxisX.WholeRange.MinValue = 0;
        diagram.AxisX.WholeRange.MaxValue = 31;
        settings.Titles.Add(new ChartTitle()
        {
            Text = "DataVisualization  Chart For Days",
            Font = new Font("Tahoma", 18)
        });
    }

    if (ViewBag.Type == "Months")
    {
        settings.Titles.Add(new ChartTitle()
        {
            Text = "DataVisualization  Chart For Month",
            Font = new Font("Tahoma", 18)
        });
        diagram.AxisX.Title.Text = "Months";
        diagram.AxisX.WholeRange.MinValue = 1;
        diagram.AxisX.WholeRange.MaxValue = 12;
    }

    if (ViewBag.Type == "Time")
    {
        settings.Titles.Add(new ChartTitle()
        {
            Text = "DataVisualization  Chart For time",
            Font = new Font("Tahoma", 18)
        });
        diagram.AxisX.Title.Text = "Time";
        diagram.AxisX.WholeRange.MinValue = 1;
        diagram.AxisX.WholeRange.MaxValue = 24;
    }

    
    if (ViewBag.Type == "Day")
    { 
        settings.Titles.Add(new ChartTitle()
        {
            Text = "DataVisualization  Chart For Day",
            Font = new Font("Tahoma", 18)
        });
 
        diagram.AxisX.Title.Text = "Day";
        diagram.AxisX.WholeRange.MinValue = 1;
        diagram.AxisX.WholeRange.MaxValue = 12;
    }
    if (ViewBag.Type =="Night")
    {
        settings.Titles.Add(new ChartTitle()
        {
            Text = "DataVisualization  Chart For Night",
            Font = new Font("Tahoma", 18)
        });
        diagram.AxisX.Title.Text = "Night";
        diagram.AxisX.WholeRange.MinValue = 12;
        diagram.AxisX.WholeRange.MaxValue = 1;
    }
    diagram.AxisX.Interlaced = true;

    //diagram.AxisX.Logarithmic = true;
    //diagram.AxisX.LogarithmicBase = 2;

    diagram.AxisX.WholeRange.Auto = false;
    diagram.AxisX.WholeRange.AutoSideMargins = false;
  
    ////////////////////////////////////////////////////



    //////// Y Axis Setting  /////////////////////////
    diagram.AxisY.Title.Visibility = DefaultBoolean.True;
    diagram.AxisY.Title.Text = "Kbps";
    diagram.AxisY.Interlaced = true;
    //diagram.AxisY.Logarithmic = true;
    //diagram.AxisY.LogarithmicBase = 100;

    diagram.AxisY.WholeRange.Auto = false;
    diagram.AxisY.WholeRange.AutoSideMargins = false;
    diagram.AxisY.WholeRange.MinValue = 0;
    diagram.AxisY.WholeRange.MaxValue = 3000;
    /////////////////////////////////////////////////////
  

    
    settings.Titles.Add(new ChartTitle()
    {
        Alignment = StringAlignment.Near,
        Font = new Font("Tahoma", 10),
        //Text = "Category: " + options.Category
    });
    






    //settings.CustomDrawAxisLabel = (s, e) =>
    //    {
          
    //        e.Item.Axis.VisualRange.SetMinMaxValues(1, 30);
    //        // e.Item.Text ="a" ;
    //    };


    settings.CustomDrawSeriesPoint = (s, e) =>
  {


          var nameOfProperty = "Target";
          var propertyInfo = e.SeriesPoint.Tag.GetType().GetProperty(nameOfProperty);
          var value = propertyInfo.GetValue(e.SeriesPoint.Tag, null);


          

          if (Convert.ToDouble(value) > 0)
          {
              e.LabelText = "+" + value + "%";
          }
          else
          {
              e.LabelText = value + "%";
          }
          if (Convert.ToDouble(value) < -3)
              e.SeriesDrawOptions.Color = Color.Yellow;
          if (Convert.ToDouble(value) > -3 && Convert.ToDouble(value) <= 3)
              e.SeriesDrawOptions.Color = Color.LightSkyBlue;
          if (Convert.ToDouble(value) > 3)
              e.SeriesDrawOptions.Color = Color.Red;

         


      };


//    settings.CustomPaint = (s, e) =>
//    {

//    //    Image newImage = Image.FromFile("day.png" );
        
        
//    //// Create Point for upper-left corner of image.
//    //Point ulCorner = new Point(100, 100);
//    //e.Graphics.DrawImage(newImage, ulCorner);
////<img src="~/chart/day.png" />
       
//        string filename = Server.MapPath("~/chart/day.png");
//        Image newImage = Image.FromFile(filename);

//    //Graphics graphics = controlToDrawOver.CreateGraphics();

//    // Note rectangle x,y coordinates are relative to 
//    // the 'controlToDrawOver' object.
//        Point ulCorner = new Point(100, 10);
//        e.Graphics.DrawImage(newImage, ulCorner);
       

//    };
      
    settings.BoundDataChanged = (sender, e) =>
    {
        MVCxChartControl chart = (MVCxChartControl)sender;
        double max = double.NegativeInfinity;
        double min = double.PositiveInfinity;
        double average = 0;
        foreach (SeriesPoint point in chart.Series[0].Points)
        {
            if (point.Values[0] > max)
                max = point.Values[0];
            if (point.Values[0] < min)
                min = point.Values[0];
            average += point.Values[0];
        }



        average /= chart.Series[0].Points.Count;
        chart.Titles[0].Text += "\nMin price: " + min.ToString("0.00");
        chart.Titles[0].Text += "\nMax price: " + max.ToString("0.00");
        chart.Titles[0].Text += "\nAverage price: " + average.ToString("0.00");
    };
    @Html.DevExpress().Chart(settings).Bind(Model).GetHtml()
}


